// maf_checkThread.c -- check threading condition of an alignment for the reference, the alignments must be projected on reference
// first parameter is testing file
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "util.h"
#include "maf.h"

int main(int argc, char **argv) {
  int lastEnd,  totalError, thread=1;
  struct mafFile *mf;
  struct mafAli *b;
  struct mafComp *c; 

  if ( argc < 2) 
    fatal("maf_checkThread -- Check threading condition or check overlap of top row in alignments.\n args: projected-maf-flie [overlap]\nBy default the threading condition is checked; if \"overlap\" is specified, only overlapping is checked.\n");

  if ( argc == 3 && strcmp(argv[2], "overlap")==0 )
    thread = 0;

  totalError = 0;

  mf = mafOpen(argv[1], 0);
  lastEnd = -1;
  while ((b = mafNext(mf)) != NULL) {
    c = b->components;
    if ( thread == 1) {
      if ( c->start != lastEnd + 1) {
	printf("%s not threaded at %d ", c->src, c->start);
	totalError++;
      }
    }
    else {
      if ( c->start < lastEnd+1) {
	printf("%s overlapped at %d ", c->src, c->start);
	totalError++;
      }
    }
    lastEnd = c->start + c->size - 1;
    mafAliFree(&b);
  }
  mafFileFree(&mf);
  printf("Total Errors: %d\n", totalError);

  return 0;
}
